package main

import "unsafe"

var data []byte

func main() {}

//go:export boot
func Boot() {
	data = LoadFile()
}

//go:export update
func Update() {
	Draw(data)
}

func LoadFile() []byte {
	fileSize := 1
	raw := make([]byte, fileSize)
	rawPtr := unsafe.Pointer(unsafe.SliceData(raw))
	loadRomFile(rawPtr, uint32(fileSize))
	return raw
}

func Draw(raw []byte) {
	rawPtr := unsafe.Pointer(unsafe.SliceData(raw))
	draw(rawPtr, uint32(len(raw)))
}

//go:wasmimport fs load_rom_file
func loadRomFile(bufPtr unsafe.Pointer, bufLen uint32)

//go:wasmimport graphics draw
func draw(bufPtr unsafe.Pointer, bufLen uint32)
